<template>
  <div class="app-container">
    <div class="operation">
      <el-button class="success" style="float: left;" @click="form_add">新增车次</el-button>
      <el-button class="danger" style="float: left;" @click="handleDelete">减少车次</el-button>
      <el-button class="import" style="float: right;" @click="handleHistoryRecords">历史记录</el-button>
    </div>
    <div class="search" />

    <div class="table">
      <el-table id="table" :key="table.tableKey" v-loading="table.listLoading" element-loading-text="给我一点时间" :data="table.list" border fit highlight-current-row style="width: 100%;" :row-style="rowStyle" :cell-style="cellStyle" class="elTable table-fixed" row-key="id" @selection-change="handleSelect">
        <el-table-column type="selection" min-width="50" />
        <el-table-column label="车次" min-width="130px" align="center">
          <template slot-scope="scope">
            <span v-if="scope.row.NoEdit">{{ scope.row.sort }}</span>
            <el-input v-if="scope.row.Edit" v-model.trim="scope.row.sort" type="number" style="width:80%;padding:10px 0;" />
          </template>
        </el-table-column>
        <el-table-column label="配方名称" min-width="130px" align="center">
          <template slot-scope="scope">
            <span v-if="scope.row.NoEdit">{{ scope.row.ftname }}</span>
            <el-select v-if="scope.row.Edit" v-model="scope.row.ftid" filterable placeholder="" class="filter-item" style="width:80%;padding:10px 0;" @change="(value)=> {changeformulaName(value, scope.row)}">
              <el-option v-for="(item,index) in formulaNameList" :key="index" :label="item.tname" :value="item.id" />
            </el-select>
          </template>
        </el-table-column>
        <el-table-column label="TMR编号" prop="weight" min-width="130px" align="center">
          <template slot-scope="scope">
            <span v-if="scope.row.NoEdit">{{ scope.row.tmrcode }}</span>
            <el-select v-if="scope.row.Edit" v-model="scope.row.tmrid" filterable placeholder="" class="filter-item" style="width:80%;padding:10px 0;" @change="(value)=> {changeTMRNumber(value, scope.row)}">
              <el-option v-for="(item,index) in TMRNumberList" :key="index" :label="item.tname" :value="item.id" />
            </el-select>
          </template>
        </el-table-column>
        <el-table-column label="班次" min-width="130px" align="center">
          <template slot-scope="scope">
            <span v-if="scope.row.NoEdit">{{ scope.row.times }}</span>
            <el-select v-if="scope.row.Edit" v-model="scope.row.times" filterable placeholder="" class="filter-item" style="width:80%;padding:10px 0;" @change="(value)=> {changeTimes(value, scope.row)}">
              <el-option v-for="(item,index) in frequencyList" :key="index" :label="item.name" :value="item.id" />
            </el-select>
          </template>
        </el-table-column>
        <el-table-column label="撒料计划车次跟随" min-width="130px" align="center">
          <template slot-scope="scope">
            <span v-if="scope.row.NoEdit">{{ scope.row.lppcode }}</span>
            <el-select v-if="scope.row.Edit" v-model="scope.row.lppid" filterable placeholder="" class="filter-item" style="width:80%;padding:10px 0;" @change="(value)=> {changeCarFollow(value, scope.row)}">
              <el-option v-for="(item,index) in carFollowList" :key="index" :label="item.lppcode" :value="item.id" />
            </el-select>
          </template>
        </el-table-column>
        <el-table-column label="生效" min-width="130px" align="center">
          <template slot-scope="scope">
            <el-switch v-model="scope.row.enable" :disabled="scope.row.NoEdit==true" active-color="#13ce66" inactive-color="#ff4949" :active-value="1" :inactive-value="0" @change="change_enable(scope.$index, scope.row)" />
          </template>
        </el-table-column>
        <el-table-column label="时间" min-width="180px" align="center">
          <template slot-scope="scope">
            <span v-if="scope.row.NoEdit">{{ scope.row.ptime }}</span>
            <el-time-picker v-if="scope.row.Edit" v-model="scope.row.ptime" type="datetime" placeholder="选择时间" format="HH:mm" value-format="HH:mm" style="display: inline-block;width: 95%;" />
          </template>
        </el-table-column>
        <el-table-column label="单车操作重量" min-width="130px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.maxweight }}</span>
          </template>
        </el-table-column>
        <el-table-column label="混料重量" min-width="130px" align="center">
          <template slot-scope="scope">
            <span v-if="scope.row.NoEdit">{{ scope.row.operateweight }}</span>
            <el-input v-if="scope.row.Edit" v-model="scope.row.operateweight" type="number" style="width:80%;padding:10px 0;" />
          </template>
        </el-table-column>
        <el-table-column label="操作" align="center" width="320" class-name="small-padding fixed-width" fixed="right">
          <template slot-scope="{row}">
            <!-- 新增 -->
            <el-button v-if="row.isCreate" class="miniSuccess" :disabled="isokDisable" @click="add_dialog_save(row)">保存</el-button>
            <el-button v-if="row.isCreate" class="minCancel" @click="add_cancel(row)">取消</el-button>
            <!-- 编辑 -->
            <el-button v-if="row.isUpdate" class="miniSuccess" @click="form_edit(row)">编辑</el-button>
            <el-button v-if="row.isUpdate" class="miniDanger" @click="form_delete(row)">删除</el-button>
            <!-- 编辑保存 -->
            <el-button v-if="row.isUpdateSave" class="miniSuccess" :disabled="isokDisable" @click="form_edit_save(row)">保存</el-button>
            <el-button v-if="row.isUpdateSave" class="minCancel" @click="edit_cancel(row)">取消</el-button>

          </template>
        </el-table-column>
      </el-table>
    </div>

    <!-- 历史记录 -->
    <el-dialog :title="textMap[history.dialogStatus]" :destroy-on-close="true" :visible.sync="history.dialogFormVisible" :close-on-click-modal="false" width="90%">
      <div class="app-history">
        <div class="search">
          <el-date-picker v-model="history.getdataListParm.parammaps.date" type="date" placeholder="请选择历史记录时间" :clearable="false" style="width: 180px;" format="yyyy-MM-dd" value-format="yyyy-MM-dd" @change="changeDate" />
          <el-button class="successBorder" @click="handleApplication">应用</el-button>
        </div>
        <div class="table">
          <el-table :key="history.tableKey" v-loading="history.listLoading" element-loading-text="给我一点时间" :data="history.list" border fit highlight-current-row style="width: 100%;" :row-style="rowStyle" :cell-style="cellStyle" class="elTable table-fixed">
            <el-table-column label="车次" min-width="130px" align="center">
              <template slot-scope="scope">
                <span>{{ scope.row.sort }}</span>
              </template>
            </el-table-column>
            <el-table-column label="配方名称" min-width="130px" align="center">
              <template slot-scope="scope">
                <span>{{ scope.row.ftname }}</span>
              </template>
            </el-table-column>
            <el-table-column label="TMR编号" prop="weight" min-width="130px" align="center">
              <template slot-scope="scope">
                <span>{{ scope.row.tmrcode }}</span>
              </template>
            </el-table-column>
            <el-table-column label="班次" min-width="130px" align="center">
              <template slot-scope="scope">
                <span>{{ scope.row.times }}</span>
              </template>
            </el-table-column>
            <el-table-column label="发料计划车次跟随" min-width="130px" align="center">
              <template slot-scope="scope">
                <span>{{ scope.row.lppcode }}</span>
              </template>
            </el-table-column>
            <el-table-column label="生效" min-width="130px" align="center">
              <template slot-scope="scope">
                <el-switch v-model="scope.row.enable" :disabled="scope.row.NoEdit==true" active-color="#13ce66" inactive-color="#ff4949" :active-value="1" :inactive-value="0" @change="change_enable(scope.$index, scope.row)" />
              </template>
            </el-table-column>
            <el-table-column label="时间" min-width="180px" align="center">
              <template slot-scope="scope">
                <span>{{ scope.row.ptime }}</span>
              </template>
            </el-table-column>
            <el-table-column label="单车操作重量" min-width="130px" align="center">
              <template slot-scope="scope">
                <span>{{ scope.row.maxweight }}</span>
              </template>
            </el-table-column>
            <el-table-column label="混料重量" min-width="130px" align="center">
              <template slot-scope="scope">
                <span>{{ scope.row.operateweight }}</span>
              </template>
            </el-table-column>
          </el-table>
          <pagination v-show="history.total>0" :total="history.total" :page.sync="history.getdataListParm.offset" :limit.sync="history.getdataListParm.pagecount" @pagination="getHistoryList" />
        </div>
      </div>
      <div slot="footer" class="dialog-footer" style="bottom: 10px;">
        <el-button class="cancelClose" @click="history.dialogFormVisible = false; ">关闭</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { GetDataByName, GetDataByNames, PostDataByName, failproccess, ExecDataByConfig } from '@/api/common'
import Sortable from 'sortablejs'
import Pagination from '@/components/Pagination'
import Cookies from 'js-cookie'
import { MessageBox } from 'element-ui'
export default {
  name: 'PremixedPlan',
  components: { Pagination },
  data() {
    return {
      send_select_list: [
        { name: 'getTMRYHList', offset: 0, pagecount: 0, parammaps: { pastureid: Cookies.get('pastureid') } },
        { name: 'getFTYHList', offset: 0, pagecount: 0, parammaps: { pastureid: Cookies.get('pastureid') } }
      ],
      formulaNameList: [], // 配方名称
      TMRNumberList: [], // TMR编号

      // 班次
      maxTime: {
        getMaxTimesParm: {
          name: 'getSysoptEnable',
          page: 1,
          offset: 1,
          pagecount: 1,
          returntype: 'Map',
          parammaps: {
            pastureid: Cookies.get('pastureid'),
            inforname: 'times'
          }
        }
      },
      frequencyList: [], // 班次
      getCarFollowParm: {
        name: 'getLPPCodeList',
        offset: 0,
        pagecount: 0,
        parammaps: {
          pastureid: Cookies.get('pastureid'),
          times: ''
        }
      },
      carFollowList: [], // 发料计划车次跟随

      table: {
        getdataListParm: {
          name: 'getPremixplanList',
          page: 1,
          offset: 1,
          pagecount: 10,
          returntype: 'Map',
          parammaps: {
            pastureid: Cookies.get('pastureid')
          }
        },
        tableKey: 0,
        list: [],
        total: 0,
        listLoading: true
      },
      history: {
        dialogFormVisible: false,
        dialogStatus: '',
        temp: {},
        rules: {},
        tableKey: 0,
        list: [],
        total: 0,
        listLoading: true,

        getdataDateParm: {
          name: 'getPPMaxDate',
          page: 1,
          offset: 1,
          pagecount: 10,
          returntype: 'Map',
          parammaps: {
            pastureid: Cookies.get('pastureid')
          }
        },
        getdataListParm: {
          name: 'getPremixplanListDate',
          page: 1,
          offset: 1,
          pagecount: 10,
          returntype: 'Map',
          parammaps: {
            pastureid: Cookies.get('pastureid'),
            date: ''
          }
        }
      },
      textMap: {
        history: '历史记录'
      },
      selectList: [],
      isokDisable: false,
      requestParam: {},
      rowStyle: { maxHeight: 50 + 'px', height: 45 + 'px' },
      cellStyle: { padding: 0 + 'px' },
      dropState: false
    }
  },
  created() {
    this.get_table_data()
    this.get_select_list()
    this.getIsDisplay()
  },
  methods: {
    get_select_list() {
      GetDataByNames(this.send_select_list).then(response => {
        this.TMRNumberList = response.data.getTMRYHList.list
        this.formulaNameList = response.data.getFTYHList.list
      })
    },
    getIsDisplay() {
      GetDataByName(this.maxTime.getMaxTimesParm).then(response => {
        if (response.data.list[0].inforvalue == 1) {
          this.frequencyList = [{ id: '1', name: '第一班' }]
        } else if (response.data.list[0].inforvalue == 2) {
          this.frequencyList = [{ id: '1', name: '第一班' }, { id: '2', name: '第二班' }]
        } else if (response.data.list[0].inforvalue == 3) {
          this.frequencyList = [{ id: '1', name: '第一班' }, { id: '2', name: '第二班' }, { id: '3', name: '第三班' }]
        } else if (response.data.list[0].inforvalue == 4) {
          this.frequencyList = [{ id: '1', name: '第一班' }, { id: '2', name: '第二班' }, { id: '3', name: '第三班' }, { id: '4', name: '第四班' }]
        }
      })
    },
    get_table_data() {
      this.table.listLoading = true
      GetDataByName(this.table.getdataListParm).then(response => {
        console.log('table数据', response.data.list)
        if (response.data.list !== null) {
          for (let i = 0; i < response.data.list.length; i++) {
            this.$set(response.data.list[i], 'Edit', false) // 编辑
            this.$set(response.data.list[i], 'NoEdit', true) // 不可编辑/输入
            this.$set(response.data.list[i], 'groupEdit', false) // 饲料组编辑
            this.$set(response.data.list[i], 'groupNoEdit', true) // 饲料组不可编辑
            this.$set(response.data.list[i], 'isCreate', false) // 新增操作
            this.$set(response.data.list[i], 'isUpdate', true) // 编辑操作
            this.$set(response.data.list[i], 'isUpdateSave', false) // 编辑保存
          }
          this.table.list = response.data.list
          this.table.pageNum = response.data.pageNum
          this.table.pageSize = response.data.pageSize
          this.rowDrop()
          this.table.total = response.data.total
        } else {
          this.table.list = []
        }

        setTimeout(() => {
          this.table.listLoading = false
        }, 100)
      })
    },
    // 配方名称
    changeformulaName(item, row) {
      row.ftname = this.formulaNameList.find(obj => obj.id == item).tname
    },
    // TMR编号
    changeTMRNumber(item, row) {
      row.tmrcode = this.TMRNumberList.find(obj => obj.id == item).tname
      row.maxweight = this.TMRNumberList.find(obj => obj.id == item).maxstirfeed
    },
    // 撒料计划车次跟随列表
    changeCarFollow(item, row) {
      row.lppcode = this.carFollowList.find(obj => obj.id == item).lppcode
    },
    // 班次
    changeTimes(item, row) {
      console.log(item, row)
      this.getCarFollowParm.parammaps.times = item
      this.getCarFollowList(row)
    },
    // 撒料计划车次跟随列表
    getCarFollowList(row) {
      GetDataByName(this.getCarFollowParm).then(response => {
        console.log('撒料计划车次跟随列表数据', response.data.list)
        if (response.data.list !== null) {
          this.carFollowList = response.data.list
          row.lppid = this.carFollowList[0].id
          row.lppcode = this.carFollowList[0].lppcode
        }
      })
    },
    change_enable() {
      console.log('点击了生效')
    },
    // 行拖拽
    rowDrop() {
      console.log(document.querySelector('#table .el-table__body-wrapper tbody'))
      const tbody = document.querySelector('#table .el-table__body-wrapper tbody')
      const that = this
      var sortable = Sortable.create(tbody, {
        disabled: that.dropState,
        onChoose({ newIndex, oldIndex }) {
          if (that.dropState == true) {
            sortable.destroy()
          }
        },
        onEnd({ newIndex, oldIndex }) {
          const currRow = that.table.list.splice(oldIndex, 1)[0]
          that.table.list.splice(newIndex, 0, currRow)
          console.log('索引', newIndex)
          console.log('拖动数据', currRow)
          console.log('上', that.table.list[newIndex - 1])
          console.log('下', that.table.list[newIndex + 1])
        }
      })
    },

    // 模板新增
    form_add() {
      this.dropState = true
      console.log('点击了新增车次')
      // 编辑true/不可编辑false
      // 新增操true,编辑false，编辑保存false
      for (let i = 0; i < this.table.list.length; i++) {
        if (this.table.list[i].Edit === true) {
          console.log(123)
          this.$message({ type: 'error', message: '当前内容未保存，请点击取消或保存继续进行操作', duration: 2000 })
          return false
        }
      }
      var sort = 0
      if (this.table.list.length > 0) {
        sort = parseInt(this.table.list[this.table.list.length - 1].sort) + 1
      } else {
        sort = 0
      }
      this.table.list.unshift({ 'myId': (new Date()).valueOf(), 'Edit': true, 'NoEdit': false, 'isCreate': true, 'isUpdate': false, 'isUpdateSave': false, 'enable': 1, 'sort': sort, 'ftid': '', 'ftname': '', 'tmrcode': '', 'tmrid': '', 'times': '', 'lppcode': '', 'lppid': '', 'ptime': '', 'maxweight': '', 'operateweight': '' })
    },
    add_dialog_save(row) {
      console.log('点击了新增保存', row)

      if (row.sort == '' && row.ftid == '' && row.tmrid == '' && row.times == '' && row.operateweight == '') {
        this.$message({ type: 'error', message: '车次/配方名称/TMR编号/班次/混料重量不能为空', duration: 2000 })
        return false
      } else if (row.ftid == '' && row.tmrid == '' && row.times == '' && row.operateweight == '') {
        this.$message({ type: 'error', message: '配方名称/TMR编号/班次/混料重量不能为空', duration: 2000 })
        return false
      } else if (row.tmrid == '' && row.times == '' && row.operateweight == '') {
        this.$message({ type: 'error', message: 'TMR编号/班次/混料重量不能为空', duration: 2000 })
        return false
      } else if (row.times == '' && row.operateweight == '') {
        this.$message({ type: 'error', message: '班次/混料重量不能为空', duration: 2000 })
        return false
      } else if (row.sort == '') {
        this.$message({ type: 'error', message: '车次不能为空', duration: 2000 })
        return false
      } else if (row.ftid == '') {
        this.$message({ type: 'error', message: '配方名称不能为空', duration: 2000 })
        return false
      } else if (row.tmrid == '') {
        this.$message({ type: 'error', message: 'TMR编号不能为空', duration: 2000 })
        return false
      } else if (row.times == '') {
        this.$message({ type: 'error', message: '班次不能为空', duration: 2000 })
        return false
      } else if (row.operateweight == '') {
        this.$message({ type: 'error', message: '混料重量不能为空', duration: 2000 })
        return false
      }
      for (let i = 0; i < this.table.list.length; i++) {
        if (row.sort !== '') {
          if (row.sort == this.table.list[i].sort) {
            if (row.myId !== this.table.list[i].myId) {
              this.$message({ type: 'error', message: '车次不可重复', duration: 2000 })
              return false
            }
          }
        }
      }
      var isInteger = /^\d+$/
      if (row.sort !== '') {
        if (!isInteger.test(parseFloat(row.sort))) {
          this.$message({ type: 'error', message: '车次请输入整数', duration: 2000 })
          return false
        }
      }
      this.isokDisable = true
      setTimeout(() => {
        this.isokDisable = false
      }, 1000)
      this.requestParam.name = 'insertPremixplan'
      this.requestParam.parammaps = row
      this.requestParam.parammaps.pastureid = Cookies.get('pastureid')
      PostDataByName(this.requestParam).then(response => {
        console.log('新增保存发送参数', this.requestParam)
        if (response.msg !== 'fail') {
          this.$notify({ title: '成功', message: '保存成功', type: 'success', duration: 2000 })
          this.get_table_data()
          this.dropState = false
        } else {
          failproccess(response, this.$notify)
        }
      })
    },
    add_cancel(row) {
      console.log('点击了新增取消')
      this.dropState = false
      for (let i = 0; i < this.table.list.length; i++) {
        if (row.myId === this.table.list[i].myId) {
          var listIndex = this.table.list.indexOf(this.table.list[i])
        }
        if (listIndex > -1) {
          this.table.list.splice(listIndex, 1)
          return
        }
      }
    },

    // 模板编辑
    form_edit(row) {
      for (let i = 0; i < this.table.list.length; i++) {
        if (this.table.list[i].Edit == true) {
          this.$message({ type: 'error', message: '当前内容未保存，请点击取消或保存继续进行操作', duration: 2000 })
          return false
        }
      }
      // 编辑true,不可编辑false
      row.Edit = true
      row.NoEdit = false
      // 新增false,编辑false,编辑保存true
      row.isCreate = false
      row.isUpdate = false
      row.isUpdateSave = true
      row.lppid = String(row.lppid)
      this.getCarFollowParm.parammaps.times = row.times
      this.getCarFollowList(row)
      this.dropState = true
    },
    form_edit_save(row) {
      console.log('点击了编辑保存', row)
      if (row.ftid == '' && row.tmrid == '' && row.times == '' && row.operateweight == '') {
        this.$message({ type: 'error', message: '配方名称/TMR编号/班次/混料重量不能为空', duration: 2000 })
        return false
      } else if (row.tmrid == '' && row.times == '' && row.operateweight == '') {
        this.$message({ type: 'error', message: 'TMR编号/班次/混料重量不能为空', duration: 2000 })
        return false
      } else if (row.times == '' && row.operateweight == '') {
        this.$message({ type: 'error', message: '班次/混料重量不能为空', duration: 2000 })
        return false
      } else if (row.ftid == '') {
        this.$message({ type: 'error', message: '配方名称不能为空', duration: 2000 })
        return false
      } else if (row.tmrid == '') {
        this.$message({ type: 'error', message: 'TMR编号不能为空', duration: 2000 })
        return false
      } else if (row.times == '') {
        this.$message({ type: 'error', message: '班次不能为空', duration: 2000 })
        return false
      } else if (row.operateweight == '') {
        this.$message({ type: 'error', message: '混料重量不能为空', duration: 2000 })
        return false
      }
      for (let i = 0; i < this.table.list.length; i++) {
        if (row.sort == this.table.list[i].sort) {
          if (row.id !== this.table.list[i].id) {
            this.$message({ type: 'error', message: '车次不可重复', duration: 2000 })
            return false
          }
        }
      }
      var isInteger = /^\d+$/
      if (row.sort !== '') {
        if (!isInteger.test(parseFloat(row.sort))) {
          this.$message({ type: 'error', message: '车次请输入整数', duration: 2000 })
          return false
        }
      }

      this.isokDisable = true
      setTimeout(() => {
        this.isokDisable = false
      }, 1000)
      this.requestParam.name = 'updatePremixplan'
      this.requestParam.parammaps = row
      PostDataByName(this.requestParam).then(response => {
        console.log('新增保存发送参数', this.requestParam)
        if (response.msg !== 'fail') {
          this.$notify({ title: '成功', message: '保存成功', type: 'success', duration: 2000 })
          this.get_table_data()
          this.dropState = false
        } else {
          failproccess(response, this.$notify)
        }
      })
    },
    edit_cancel(row) {
      console.log('点击了编辑取消')
      // 编辑false,不可编辑true
      row.Edit = false
      row.NoEdit = true
      // 新增false,编辑true,编辑保存false
      row.isCreate = false
      row.isUpdate = true
      row.isUpdateSave = false
      this.get_table_data()
      this.dropState = false
    },

    handleSelect(val) {
      console.log('勾选数据', val)
      this.selectList = val
    },

    // 历史记录
    handleHistoryRecords() {
      console.log('点击了历史记录')
      this.history.dialogStatus = 'history'
      this.history.dialogFormVisible = true
      this.getDateList()
    },
    // 历史时间
    getDateList() {
      GetDataByName(this.history.getdataDateParm).then(response => {
        console.log('table数据', response.data.list)
        if (response.data.list !== null) {
          this.history.getdataListParm.parammaps.date = response.data.list[0].maxdate
          this.getHistoryList()
        } else {
          this.history.getdataListParm.parammaps.date = ''
        }
      })
    },
    changeDate() {
      this.getHistoryList()
    },
    // 应用
    handleApplication() {
      console.log('点击了应用')
      MessageBox.confirm('是否确认将' + this.history.getdataListParm.parammaps.date + '的数据应用到当前?', {
        confirmButtonText: '确认', cancelButtonText: '取消', type: 'warning'
      }).then(() => {
        this.requestParam.name = 'applyFPdate'
        this.requestParam.parammaps = {}
        this.requestParam.parammaps.pastureid = Cookies.get('pastureid')
        this.requestParam.parammaps.date = this.history.getdataListParm.parammaps.date
        PostDataByName(this.requestParam).then(response => {
          if (response.msg === 'fail') {
            this.$notify({ title: '保存失败', message: response.data, type: 'warning', duration: 2000 })
          } else {
            this.$notify({ title: '成功', message: '保存成功', type: 'success', duration: 2000 })
            this.getHistoryIsDisplay()
            this.get_table_data()
          }
        })
      }).catch(() => {
        this.$message({ type: 'info', message: '已取消应用' })
      })
    },
    getHistoryList() {
      this.history.listLoading = true
      GetDataByName(this.history.getdataListParm).then(response => {
        console.log('table数据', response.data.list)
        if (response.data.list !== null) {
          console.log('table数据', response.data.list)
          this.history.list = response.data.list
          this.history.pageNum = response.data.pageNum
          this.history.pageSize = response.data.pageSize
          this.history.total = response.data.total
        } else {
          this.history.list = []
        }
        setTimeout(() => {
          this.history.listLoading = false
        }, 100)
      })
    },
    // 行内删除
    form_delete(row) {
      console.log(row, '点击了行删除')
      MessageBox.confirm('是否确认删除此信息?', {
        confirmButtonText: '确认', cancelButtonText: '取消', type: 'warning'
      }).then(() => {
        this.selectList = []
        this.requestParam = {}
        this.requestParam.name = 'deletePremixplan'
        this.requestParam.parammaps = {}
        this.requestParam.parammaps.pastureid = row.pastureid
        this.requestParam.parammaps.id = row.id
        PostDataByName(this.requestParam).then(response => {
          if (response.msg === 'fail') {
            this.$notify({ title: '删除失败', message: response.data, type: 'warning', duration: 2000 })
          } else {
            this.$notify({ title: '成功', message: '删除成功', type: 'success', duration: 2000 })
            this.get_table_data()
          }
        })
      }).catch(() => {
        this.$message({ type: 'info', message: '已取消删除' })
      })
    },
    // 减少车次
    handleDelete() {
      if (this.selectList.length == 0) {
        this.$message({ type: 'error', message: '请选择车次信息', duration: 2000 })
      } else {
        MessageBox.confirm('当前选中' + this.selectList.length + '条信息，是否删除?', {
          confirmButtonText: '确认', cancelButtonText: '取消', type: 'warning'
        }).then(() => {
          console.log(this.selectList)
          this.requestParam.common = { 'returnmap': '0' }
          this.requestParam.data = []
          this.requestParam.data[0] = { 'name': 'insertSpotList', 'resultmaps': { 'list': this.selectList } }
          this.requestParam.data[0].children = []
          this.requestParam.data[0].children[0] = {            'name': 'deletePremixplan', 'type': 'e', 'parammaps': {
              id: '@insertSpotList.id',
              pastureid: '@insertSpotList.pastureid'
            }          }
          ExecDataByConfig(this.requestParam).then(response => {
            console.log('删除保存发送参数', this.requestParam)
            if (response.msg === 'fail') {
              this.$notify({ title: '删除失败', message: response.data, type: 'warning', duration: 2000 })
            } else {
              this.$notify({ title: '', message: '删除成功', type: 'success', duration: 2000 })
              this.get_table_data()
            }
          })
        })
      }
    }

  }
}

</script>

<style lang="scss" scoped>
.search {
  clear: both;
}
.table {
  margin-top: 10px;
}
/deep/ .el-time-panel__btn {
  height: 26px !important;
}
</style>
